#include "stdafx.h"
#include<extgl.h>
#include<vcg/Point3.h>
#include<vcg/Matrix44.h>
#include<string>
//#include<GL/gl.h>
//#include<GL/glu.h>
#include <il/il.h>
#include <il/ilu.h>
#include <il/ilut.h>
  
using namespace vcg;
using namespace std;
#include<vcg/CIMsg.h>
#include<vcg/CICubeMap.h>

void CICubeMap::DrawEnvCube()
{
	Matrix44f id;
	id.SetIdentity();
	DrawEnvCube(id);
}

void CICubeMap::DrawEnvCube(Matrix44f &tr)
{
	static Point3f cube_vertices[8] = {

  Point3f(-1.0,  1.0, -1.0), // l t f
  Point3f(-1.0, -1.0, -1.0), // l b f
  Point3f( 1.0, -1.0, -1.0), // r b f
  Point3f( 1.0,  1.0, -1.0), // r t f

  Point3f(-1.0,  1.0,  1.0), // l t b
  Point3f(-1.0, -1.0,  1.0), // l b b
  Point3f( 1.0, -1.0,  1.0), // r b b
  Point3f( 1.0,  1.0,  1.0), // r t b
};

static int cube_faces[6][4] = {

  {3, 2, 6, 7}, // right
  {4, 5, 1, 0}, // left
  {4, 0, 3, 7}, // top
  {1, 5, 6, 2}, // bottom
  {7, 6, 5, 4}, // back
  {0, 1, 2, 3}, // front
};

	Matrix44f ii=tr;
	ii.Invert();
	
	glMatrixMode(GL_MODELVIEW);
	glPushAttrib(GL_ENABLE_BIT|GL_CURRENT_BIT); // Pushes the display list bits 
	glPushMatrix();
	glLoadIdentity();
	
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_1D);
  glDisable(GL_TEXTURE_2D);
  glEnable(GL_TEXTURE_CUBE_MAP_ARB);
	CIMsg::checkGLError("glEnable(GL_TEXTURE_CUBE_MAP_ARB);");
	glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,ti);
	CIMsg::checkGLError("glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,ti);");
	glDepthMask(false);
	
	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_ARB);
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_ARB);
	glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_ARB);

	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
	glEnable(GL_TEXTURE_GEN_R);
	
	glTexParameterf(GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	CIMsg::checkGLError("glTexParameterf(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER)");
	glTexParameterf(GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	CIMsg::checkGLError("glTexParameterf(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER)");

	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	glMatrixMode(GL_TEXTURE);
	glPushMatrix();// Texture
	glLoadIdentity();
	glMultMatrix(ii);
	
 //	LQ.track.inverse().applyGL();
  for (int i=0; i<6; ++i) 
	{
    glBegin(GL_QUADS);
		for (int j=0; j<4; ++j) {
 			glNormal(cube_vertices[cube_faces[i][j]]);
      glVertex(cube_vertices[cube_faces[i][j]]);
    }
    glEnd();
		
  }
	glPopMatrix();// Texture
	glMatrixMode(GL_MODELVIEW);

	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	glDisable(GL_TEXTURE_GEN_R);
	glDisable(GL_TEXTURE_CUBE_MAP_ARB);
	glDepthMask(true);

glPopMatrix();
glPopAttrib();
}

bool CICubeMap::Load(const char *basename)
{
	if(!SupportedExtensions.ARB_texture_cube_map) 
			{
				AfxMessageBox("Warning: Your graphics hw does not support ARB_texture_cube_map\n");
				return false;
			}
	glPushAttrib(GL_ENABLE_BIT);
	glEnable(GL_TEXTURE_CUBE_MAP_ARB);
	glDisable(GL_TEXTURE_1D);
  glDisable(GL_TEXTURE_2D);
	if(ti==0) 
	{
			glGenTextures(1,&ti);
	}
	glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,ti);
	string exts[6];
	GLenum targets[6];

	glTexParameterf(GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	CIMsg::checkGLError("glTexParameterf(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER)");
	glTexParameterf(GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	CIMsg::checkGLError("glTexParameterf(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER)");

	exts[0]="_negx";targets[0]=GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB;
	exts[1]="_posx";targets[1]=GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB;
	exts[2]="_negy";targets[2]=GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB;
	exts[3]="_posy";targets[3]=GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB;
	exts[4]="_negz";targets[4]=GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB;
	exts[5]="_posz";targets[5]=GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB;
		
	for(int i=0;i<6;++i)
		{
			ILuint ili;
			ilGenImages(1,&ili);
			ilBindImage(ili);
			
			string filename=basename;
			string ext=basename; ext.erase(0,ext.find_last_of('.')); 
			filename.resize(filename.find_last_of('.'));
			filename.append(exts[i]);
			filename.append(ext);
			TRACE("read cube face %i '%s'\n",i,filename.c_str());
			ilLoad(IL_TYPE_UNKNOWN ,ILstring(filename.c_str()));
			int w=ilGetInteger(IL_IMAGE_WIDTH );
			int h=ilGetInteger(IL_IMAGE_HEIGHT );
			glTexImage2D(targets[i],0,3,w,h,0,GL_RGB,GL_UNSIGNED_BYTE,ilGetData());
			CIMsg::checkGLError("glTexImage2D");
			//gluBuild2DMipmaps(targets[i],3,64,64,GL_RGB,GL_UNSIGNED_BYTE,ilGetData());
			CIMsg::checkGLError("gluBuild2DMipmaps");
	
		}

	glPopAttrib();
	return true;
}

